/* just a try ; this must now be included in partimage 
 * must be called with major and minor and will provide you a name like this one
 * '/dev/mapper/vg-lv' that can be used like any /dev/hdXX entry.
 */

/* released under GNU GPL 2 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

/* return 0 on success, 1 on error */
unsigned char getLVMNameFromMajorMinor(unsigned char major,
		unsigned char minor, char **LVMName)
{
	DIR *dir;
	struct dirent *d;
	struct stat s;
	unsigned int n;
	char *fn;

	dir=opendir("/dev/mapper");
	if (!dir) {
		printf("impossible to open /dev/mapper: %s\n", strerror(errno));
		exit(1);
	}

	while ( (d=readdir(dir)) ) {
		printf("%s\n", d->d_name);
		n = strlen(d->d_name) + strlen("/dev/mapper/") + 1;
		fn = new char[n];
		strcpy(fn, "/dev/mapper/");
		strcat(fn, d->d_name);
		*(fn+n-1) = '\0';

		stat(fn, &s);

		if (S_ISBLK(s.st_mode) &&
				(unsigned char)(s.st_rdev/256) == major &&
				(unsigned char)(s.st_rdev%256) == minor )
			{
				*LVMName = fn;
				closedir(dir);
				return 0;
			}
		else {
			delete []fn;
			fn = NULL;
		}
			
			
	}
	closedir(dir);
	return 1;
}

int main()
{
	char *s;
	getLVMNameFromMajorMinor(254, 0, &s);
	printf("trouve : %s\n", s);
	delete []s;
	return 0;
}
	


